package NFP.Algorithms;

import java.util.List;

import seg.jUCMNav.nfp.generated.*;

public class AggregateAvailability {

	private List<Availability> Availabilities;
	private CompositionType composition;
	private Availability aggregatedAvailability;
	
	public Availability getAggregateAvailability
	(List<Availability> Availabilities,CompositionType composition){
		this.Availabilities=Availabilities;
		this.composition=composition;
		initialize();
		if(this.composition == CompositionType.Sequence || this.composition == CompositionType.Loop
				|| this.composition == CompositionType.Concurrency){
			for (Availability AV : this.Availabilities) {
				this.aggregatedAvailability.setAvailabilityLevel
				(this.aggregatedAvailability.getAvailabilityLevel()*AV.getAvailabilityLevel());
			}
		}
		if(this.composition == CompositionType.ConditionalBranching){
			for (Availability AV : this.Availabilities) {
				aggregatedAvailability.setAvailabilityLevel
				(Math.min(aggregatedAvailability.getAvailabilityLevel(),AV.getAvailabilityLevel()));
			}
		}
		if(this.composition == CompositionType.Discriminator){
			for (Availability AV : this.Availabilities) {
				aggregatedAvailability.setAvailabilityLevel
				(1-(aggregatedAvailability.getAvailabilityLevel()*(1-AV.getAvailabilityLevel())));
			}
		}
		return aggregatedAvailability;
	}

	private void initialize() {
		aggregatedAvailability= new Availability();
		aggregatedAvailability.setAvailabilityLevel(1);
	}
	
}
