package NFP.Algorithms;

import java.util.List;

import seg.jUCMNav.nfp.generated.*;

public class AggregateServersLocation {
	private List<ServerLocation> Locations;
	private ServerLocation aggregatedLocation;
	
	public ServerLocation getAggregateLocation(List<ServerLocation> Locations){
		this.Locations=Locations;
		initialize();
		for (ServerLocation loc : this.Locations) {
			for(Country c : loc.getCountries()){
				Country aggregateCountry = null;
				for(Country ac : aggregatedLocation.getCountries()){
					if(ac.getCode()==c.getCode()){
						aggregateCountry=ac;
					}
				}
				if(aggregateCountry==null){
					aggregatedLocation.getCountries().add(c);
				}
				else{
					if(!aggregateCountry.getTerritories().isEmpty() & !c.getTerritories().isEmpty()){
						for(Territory tr : c.getTerritories()){
							if(!aggregateCountry.getTerritories().contains(tr))
								aggregateCountry.getTerritories().add(tr);
						}
					}
					else{
						aggregateCountry.getTerritories().clear();
					}
				}
			}
		}
		return aggregatedLocation;
	}

	private void initialize() {
		aggregatedLocation= new ServerLocation();
	}
}
